<?php

class FszNotenVerwaltung{
	var $seminar_id;
	var $data = array();
	var $members = array();
	
	function FszNotenVerwaltung($seminar_id){
		$this->seminar_id = $seminar_id;
		$seminar =& Seminar::GetInstance($seminar_id);
		$this->members = $seminar->getMembers('autor');
		$this->config =& new FszNotenVerwaltungConfig($this->seminar_id);
		$this->restore();
	}
	
	function restore(){
		$db = new DB_Seminar();
		$this->data = array();
		$db->queryf("SELECT su.user_id, fsz_c.id as config_id, fsz_n.value, changed_by_user_id, fsz_n.chdate FROM seminar_user su 
					LEFT JOIN fsz_notenverwaltung_config fsz_c ON  fsz_c.seminar_id = su.seminar_id AND fsz_c.name='MARK'
					LEFT JOIN fsz_notenverwaltung_noten fsz_n ON fsz_n.config_id = fsz_c.id AND fsz_n.user_id=su.user_id
					WHERE su.seminar_id='%s' AND su.status='autor' ", $this->seminar_id);
		while($db->next_record()){
			$this->data[$db->f('user_id') . '-' . $db->f('config_id')] = $db->Record;
		}
	}
	
	function getValue($user_id, $config_id, $field){
		return $this->data[$user_id . '-' . $config_id][$field];
	}
	
	function setValue($user_id, $config_id, $field, $value){
		return ($this->data[$user_id . '-' . $config_id][$field] = $value);
	}
	
	function getFinalGrade($user_id){
		$final = 0;
		$c = 0;
		foreach($this->config->marks as $mid => $mark){
			if(! ($one = $this->getValue($user_id, $mid, 'value')) ) return null;
			$final += $one * $mark['weight'] ;
			$c += $mark['weight'];
		}
		if($c) return $final / $c;
		else return null;
	}
	
	function store(){
		$db = new DB_Seminar();
		$ret = 0;
		foreach($this->data as $key => $row){
			if(!is_null($row['value'])){
				if($row['chdate']){
					$db->queryf("UPDATE fsz_notenverwaltung_noten SET value='%s' WHERE user_id='%s' AND config_id='%s'",
								$row['value'], $row['user_id'], $row['config_id']);
					if($db->affected_rows()){
						$db->queryf("UPDATE fsz_notenverwaltung_noten SET changed_by_user_id='%s',chdate=UNIX_TIMESTAMP() WHERE user_id='%s' AND config_id='%s'",
								$GLOBALS['user']->id, $row['user_id'], $row['config_id']);
					}
				} else {
					$db->queryf("INSERT INTO  fsz_notenverwaltung_noten (value,user_id,config_id,changed_by_user_id,mkdate,chdate) VALUES('%s','%s','%s','%s',UNIX_TIMESTAMP(),UNIX_TIMESTAMP())",
							$row['value'], $row['user_id'], $row['config_id'], $GLOBALS['user']->id);
				}
			$ret += $db->affected_rows();
			}
		}
		if($ret) $this->restore();
		return $ret;
	}
	
}
?>
